# CodeMap : Générateur de Diagrammes de Classes PlantUML et Documentation

**CodeMap** est un outil simple qui vous permet de générer rapidement des diagrammes de classes UML ainsi que de la "documentation" pour vos projets en Java et C#. En quelques clics, vous pouvez visualiser la structure de votre code et générer toute la documentation nécessaire, le tout avec une interface intuitive.

## Fonctionnalités principales

- **Prise en charge des projets Java , PHP et C#** : Que vous travailliez sur un projet en Java en PHP ou en C#, CodeMap s'adapte pour en extraire les diagrammes UML avec précision.
- **Interface conviviale** : Choisissez simplement le chemin de votre projet, sélectionnez votre langage (Java ou C#), et indiquez si vous souhaitez générer des diagrammes UML, de la "documentation", ou les deux.
- **Génération rapide et simple** : En quelques clics, vous obtenez votre diagrammes et votre documentation.
- **Précision et clarté** : Les diagrammes générés sont directement basés sur votre code, assurant une représentation fidèle et claire.

## Installation
1. Clonez le dépôt du projet :
   ```bash
   git clone https://codefirst.iut.uca.fr/git/zayd.nahli/CodeMap.git
   ```
2. Installez les dépendances requises :
   ```bash
   pip install -r requirements.txt
   ```

## Utilisation
1. Exécutez le script principal :
   ```bash
   python main.py
   ```
2. Une interface s'ouvrira vous permettant de :
   - Sélectionner le chemin de votre projet à l'aide de l'explorateur de fichiers.
   - Indiquer si le projet est en Java ou C#.
   - Choisir le type de génération souhaité : diagrammes UML, documentation, ou les deux.
3. Cliquez sur **Générer** pour obtenir les résultats, le répertoire de sortie s'ouvrira automatiquement.

## Tâches en cours et futures
Voici une liste des fonctionnalités déjà en place et des améliorations prévues :

### Fonctionnalités déjà implémentées
- [x] Génération de diagrammes de classes UML pour les projets Java et C#.
- [x] Interface utilisateur intuitive avec explorateur de fichiers intégré.
- [x] Prise en charge de PHP

### Améliorations prévues
### Améliorations prévues
- [ ] Support pour d'autres langages :
    - [x] PHP
    - [ ] Python
    - [ ] Ruby
    - [ ] JavaScript/TypeScript
- [ ] Génération automatique de README pour les projets analysés.
- [ ] Amélioration de l'interface utilisateur (apparence et ergonomie).
- [ ] Optimisation des performances pour une génération plus rapide, notamment pour les grands projets.
- [ ] Ajout d'options de personnalisation pour les diagrammes générés, comme les couleurs, le style des lignes, etc.
- [ ] Ajout de la possibilité d'exporter les diagrammes dans différents formats (SVG, PNG, PDF).
- [ ] Fonctionnalité de mise à jour automatique pour les dépendances du projet.
- [ ] Support pour la génération de diagrammes de séquence ou d'autres types de diagrammes UML.


## Contributions
Pour contribuer, corriger des bugs ou proposer des fonctionnalités, soumettez un pr.

## Licence
Ce projet est sous licence MIT. Vous êtes libre de l'utiliser, de le modifier et de le partager.